
/*
 * DICONVHIST.C		append an INN history file to a diablo dhistory
 *			file.  Used to prime a diablo history file during
 *			switchover from INN to diablo.  Priming MAY
 *			run in parallel to diablo operation.
 *
 * (c)Copyright 1997, Matthew Dillon, All Rights Reserved.  Refer to
 *    the COPYRIGHT file in the base directory of this distribution 
 *    for specific rights granted.
 */

#include "defs.h"

int
main(int ac, char **av)
{
    char buf[16384];
    int cnt = 0;
    int enters = 0;
    int dups = 0;
    unsigned long gmt = time(NULL) / 60;
    FILE *fi;

    if (ac == 1) {
	puts("diconvhistory innhistoryfile");
	exit(0);
    }

    if ((fi = fopen(av[1], "r")) == NULL) {
	perror("open");
	exit(1);
    }

    HistoryOpen(NULL, 0);

    while (fgets(buf, sizeof(buf), fi) != NULL) {
	char *p = buf;

	if (p[0] != '<')
	    continue;
	while (*p && *p != '>')
	    ++p;
	if (*p != '>')
	    continue;
	p[1] = 0;
	if (HistoryLookup(buf, NULL) != 0) {
	    History h = { 0 };

	    h.hv = hhash(buf);
	    h.iter = (unsigned short)-1;
	    h.exp = (unsigned short)-1;
	    h.gmt = gmt;
	    HistoryAdd(buf, &h);
	    ++enters;
	} else {
	    ++dups;
	}
	++cnt;
    }
    return(0);
}

